//
// Copyright (C) 1999-2004 Toshikaz Hirabayashi
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// TOSHIKAZ HIRABAYASHI BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//
// Except as contained in this notice, the name of Toshikaz Hirabayashi shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from
// Toshikaz Hirabayashi.

#include <WScom.h>
#include <WSCvpifield.h>
#include <WSCclassInformation.h>
#include <WSCdevice.h>
#include <WSCblink.h>
#include <WSCcolorSet.h>
#include <WSCimageSet.h>
#include <WSDdev.h>
#include <WSDcolor.h>
#include <WSCfontSet.h>
#include <WSDappDev.h>

WSMFguiClassInitialize(WSCvpifield, WSCvifield);
WSMFversion(WSCvpifield, WSCvifield);

WSCvpifield::WSCvpifield(WSCbase* base, char* objname):
			WSCvifield(base, objname){

  _mask.setString("*");

  WSMFpropertyCreateStart
    WSMFparentCheckVerSrc(WSCvpifield);

  WSMFpropertyCreateEnd

}

WSCvpifield::~WSCvpifield() {
}
void WSCvpifield::setMaskChar(WSCstring mask){
  _mask.setString(mask);
}

long WSCvpifield::draw(){
  if (_ucs2 == NULL){
    _ucs2 = new WSCushort[1];
    _ucs2[0] = 0;
  }

  WSCushort* _ucs2_bk = _ucs2;
  long len = WSGFstrlenUCS2(_ucs2);

  _ucs2 = new WSCushort[len +1]; 
  WSCushort* tmp = WSGFgetUCS2((char*)_mask,WS_EN_DEFAULT);
  long i;
  for(i=0; i<len; i++){
    _ucs2[i] = tmp[0];
  }
  _ucs2[len] =0;
  WSCvifield::draw();
  delete _ucs2;
  _ucs2 =  _ucs2_bk;

  return WS_NO_ERR;
}
